/****************************************************************
File generated by Device Model Compiler: BMAC
Author: Bo Wan, 2003
Copyright 2003(c) Mixed-Signal CAD lab. University of Washington.
All rights reserved.
****************************************************************/

#ifndef HOTMOS
#define HOTMOS defined

#include "ifsim.h"
#include "cktdefs.h"
#include "gendefs.h"
#include "complex.h"
#include "noisedef.h"


/* information used to describe a single instance */

typedef struct sHOTMOSinstance {

	/* backpointer to model */
	struct sHOTMOSmodel *HOTMOSmodPtr;

	/* pointer to next instance of current model*/
	struct sHOTMOSinstance *HOTMOSnextInstance;

	/* pointer to character string naming this instance */
	IFuid HOTMOSname;

	/* pointer to start of state vector for hotmos device */
	//int HOTMOSstate;	/* in many cases not used */

// rest of the instance structure
// 1) external nodes (number storage ; row in jacobian)
// 2) internal nodes / BCE eqn (number storage ; row in jacobian)
// 2) element stamp pointers
// 3) instance parameter (internal use) declarations

//#include "defs_gen1.gc"
#include "new_defs_gen1.gc"


} HOTMOSinstance ;


/* per model data */

typedef struct sHOTMOSmodel {       /* model structure for a device */

	/* type index of this device type */
	int HOTMOSmodType;

	/* pointer to next possible model in linked list */
	struct sHOTMOSmodel *HOTMOSnextModel;

	/* pointer to list of instances that have this model */
	HOTMOSinstance * HOTMOSinstances;

	/* pointer to character string naming this model */
	IFuid HOTMOSmodName;


// rest of the model sturcture
// 1) model parameter (internal use) declarations

#include "defs_gen2.gc"



} HOTMOSmodel;

// #defines (integer id) of instance and model parameters
// and "#include" for externals
#include "defs_gen3.gh"

#include "hotmosext.h"

#endif /*defs*/

