/**********
Copyright 1990 Regents of the University of California.  All rights reserved.
Author: 1985 Thomas L. Quarles
**********/
/*
 */

#include "spice.h"
#include <stdio.h>
#include "util.h"
#include "opampdefs.h"
#include "suffix.h"


void
OPAMPdestroy(inModel)
    GENmodel **inModel;
{
    OPAMPmodel **model = (OPAMPmodel **)inModel;
    OPAMPinstance *here;
    OPAMPinstance *prev = NULL;
    OPAMPmodel *mod = *model;
    OPAMPmodel *oldmod = NULL;

    for( ; mod ; mod = mod->OPAMPnextModel) {
        if(oldmod) FREE(oldmod);
        oldmod = mod;
        prev = (OPAMPinstance *)NULL;
        for(here = mod->OPAMPinstances ; here ; here = here->OPAMPnextInstance) {
            if(prev) FREE(prev);
            prev = here;
        }
        if(prev) FREE(prev);
    }
    if(oldmod) FREE(oldmod);
    *model = NULL;
}
