/**********
Copyright 1990 Regents of the University of California.  All rights reserved.
Author: 1985 Thomas L. Quarles
**********/
/*
 */

/* actually load the current ac sensitivity information into the 
 * array previously provided 
 */

#include "spice.h"
#include <stdio.h>
#include "cktdefs.h"
#include "opampdefs.h"
#include "sperror.h"
#include "suffix.h"


int
OPAMPsAcLoad(inModel,ckt)
    GENmodel *inModel;
    CKTcircuit *ckt;
{
    register OPAMPmodel *model = (OPAMPmodel *)inModel;
    register OPAMPinstance *here;
    double   vc;
    double   ivc;

    /*  loop through all the voltage source models */
    for( ; model != NULL; model = model->OPAMPnextModel ) {

        /* loop through all the instances of the model */
        for (here = model->OPAMPinstances; here != NULL ;
                here=here->OPAMPnextInstance) {
                if(here->OPAMPsenParmNo){

                vc = *(ckt->CKTrhsOld + here->OPAMPcontPosNode)
                        -  *(ckt->CKTrhsOld + here->OPAMPcontNegNode);
                ivc = *(ckt->CKTirhsOld + here->OPAMPcontPosNode)
                        -  *(ckt->CKTirhsOld + here->OPAMPcontNegNode);

                *(ckt->CKTsenInfo->SEN_RHS[here->OPAMPbranch] +
                        here->OPAMPsenParmNo) += vc;
                *(ckt->CKTsenInfo->SEN_iRHS[here->OPAMPbranch] +
                        here->OPAMPsenParmNo) += ivc;
            }
        }
    }
    return(OK);
}

